/*
 布局js,提供页面的布局
 */
function layout(){
	"use strict";
	this.$window = $(window);
	this.$container = $("#container");
	this.$sidebar = $("#sidebar");
	this.$document = $(document);
	this.$body = $("body");
	this.flushLayoutData();
	this.sidebarCanDisplay = true;
	this.initTop = 0;
}

layout.prototype = {

	run:function(){
		this.sidebar();
		this.resizeAction();
		this.menuAction();
		this.sidebarAction();
		this.scroll();
	},
	/**
	 * 侧栏布局,处理侧栏的宽度
	 * @return
	 */
	sidebar:function(){
		var _this = this;
		var leftWidth = (this.windowWidth - this.containerWidth)/2 + this.sidebarWidth;
		if( this.windowWidth > 768 ){
			$("#body-before").stop().animate({"width":leftWidth+"px"},500);
		}else{
			$("#body-before").stop().animate({"width":0},500);
		}
	},

	/**
	 * ie版本号
	 * @type {}
	 */
	ieVersion:function(){
		var ua = navigator.userAgent;
		if( ua.indexOf("MSIE") === -1 ) return false;
		if( ua.indexOf("MSIE 9") !== -1 ) return 9;
		if( ua.indexOf("MSIE 8") !== -1 ) return 8;
		if( ua.indexOf("MSIE 7") !== -1 ) return 7;
		if( ua.indexOf("MSIE 6") !== -1 ) return 6;

	},

	/**
	 * 滚动
	 * @return {[type]} [description]
	 */
	scroll:function(){
		var initTop = 0;
		var _this = this;
		var toBottomHeight = this.sidebarHeight;
		$(window).scroll(function(){
			var scrollTop = $(document).scrollTop();
			toBottomHeight = _this.sidebarHeight - scrollTop - _this.windowHeight;
			//console.log("s"+_this.sidebarHeight);
			//console.log("w"+_this.documentHeight);
			if(scrollTop > initTop && _this.sidebarHeight < _this.documentHeight){
				//下滚动
				if( toBottomHeight < 0 ){
					_this.$sidebar.css({"position":"fixed","bottom":"0"});
					isLock = true;
				}
			} else {
				//上滚动
				if( toBottomHeight > 0 && _this.sidebarHeight < _this.documentHeight ){
					_this.$sidebar.css({"position":"relative","bottom":"auto"});
				}


			}
			initTop = scrollTop;
		});
	},

	sidebarAction:function(){
		var _this = this;
		//屏幕小于768时候的菜单隐藏和显示
		if( this.windowWidth < 768 ){
			this.$container.css({"width":this.windowWidth+"px","overflow-x":"hidden"});
			$("#show-sidebar").click(function(){
				if( _this.sidebarCanDisplay ){
					$(".right-content").css({"transform":"translate3d("+_this.sidebarWidth+"px,0,0)"});
					_this.$sidebar.css({"transform":"translate3d(0,0,0)"});
					$("#footer-nav").css({"transform":"translate3d("+_this.sidebarWidth+"px,0,0)"});
					_this.sidebarCanDisplay = false;
				}else{
					$(".right-content").css({"transform":"translate3d(0,0,0)"});
					_this.$sidebar.css({"transform":"translate3d("+-_this.sidebarWidth+"px,0,0)"});
					$("#footer-nav").css({"transform":"translate3d(0,0,0)"});
					_this.sidebarCanDisplay = true;
				}
			});

			this.$container.delegate(".right-content","click",function(){
				if( !_this.sidebarCanDisplay ){
					$(".right-content").css({"transform":"translate3d(0,0,0)"});
					_this.$sidebar.css({"transform":"translate3d("+-_this.sidebarWidth+"px,0,0)"});
					$("#footer-nav").css({"transform":"translate3d(0,0,0)"});
					_this.sidebarCanDisplay = true;
				}
			});
		}
	},


	/**
	 * 屏幕大小发生变化事件
	 */
	resizeAction:function(){
		var _this = this;
		$(window).resize(function(){
			_this.flushLayoutData();
			_this.sidebar();
		});
	},

	/**
	 * 刷新布局事件
	 * @return
	 */
	flushLayoutData:function(){

		/* 宽度和高度数据刷新 */
		this.windowWidth = this.$window.width();
		this.windowHeight = this.$window.height();	

		this.containerWidth = this.$container.width();
		this.containerHeight = this.$container.height();
		
		this.sidebarWidth = this.$sidebar.width();
		this.sidebarHeight = this.$sidebar.height();
		
		this.documentHeight = this.$document.height();

		this.adminbarOffset = this.$body.is( '.admin-bar' ) ? $( '#wpadminbar' ).height() : 0;

		/* 侧边栏数据刷新 */


	},

	/**
	 * 菜单动作
	 */
	menuAction:function(){
		var _this = this;
		//显示与隐藏
		$("#site-navigation li").hover(function(){
			var $this = $(this);
			$this.find(".sub-menu").css({"z-index":-1,"opacity":0,"left":0});
			$this.find(".sub-menu:first").animate({"left":_this.sidebarWidth,"opacity":1,"z-index":999},200);
		},function(){
			var $this = $(this);
			setTimeout(function(){
				$this.find(".sub-menu:first").animate({"left":0,"opacity":0,"z-index":-1},200);
			},400);
		});
	},


};

$(document).ready(function(){
	themeLayout = new layout();
	themeLayout.run();
});
